from pygame import Surface

from .FrameComponent import FrameComponent
from ..text import TextRenderer
from ...theme.Theme import Theme


class ResourcesFrame(FrameComponent):

    def __init__(self, theme: Theme):
        self.__textRenderer = TextRenderer(theme, "small")

        frameBorderSize = theme.frameBorderSize
        textSurface = self.__createTextSurface()
        size = (
            textSurface.get_width() + 2 * frameBorderSize,
            textSurface.get_height() + 2 * frameBorderSize
        )
        super().__init__(theme, size)

        self.moveTo((frameBorderSize, frameBorderSize))

    def __createTextSurface(self):
        textSurface = self.__textRenderer.render(
            "100<food> 200<wood> 150<stone>  10<gold>"
        )
        return textSurface

    # Component

    def render(self, surface: Surface):
        super().render(surface)

        textSurface = self.__createTextSurface()
        x, y = self.topLeft
        bs = self.theme.frameBorderSize
        surface.blit(textSurface, (x + bs, y + bs))


